#!/usr/bin/perl

use strict;
use warnings;
use Getopt::Long;
use DistroMap;
use DistroDB::Stems qw//;

my ($help, $verbose, $opt_dblist);
my $opt_repo='altlinux';

my @db=@DistroDB::Stems::mapper_stems;
#provides

GetOptions (
    'repo=s'  => \$opt_repo,
    'db=s'  => \$opt_dblist,
    'help'  => \$help,
    'verbose+'  => \$verbose,
);

@db=split(',',$opt_dblist) if $opt_dblist;

my $ddb=DistroMap::Repository->new(-repo=>$opt_repo);
foreach my $db (@db) {
    my $map=$ddb->_get_db($db);
    foreach my $key (keys(%$map)) {
	if (@{$map->{$key}}>1) {
#	    print "I:$db: $key:",join(',',@{$map->{$key}}),"\n";
	    print join(':',sort {$a cmp $b} @{$map->{$key}}),"\n";
	}
    }
}
__END__
