package DistroDB::CLI::DistroMap;

use strict;
use warnings;
use DistroDBTools;
use ProjectDBTools;

use Exporter 'import';
our @EXPORT_OK = qw/$ORIGIN $DEST $opt_use_projectdb $opt_origin_load_summary_description/;

our ($ORIGIN, $DEST, $opt_use_projectdb, $opt_origin_load_summary_description);
our $verbose=0;

our @LONGOPT=(
    'origin=s'  => \$ORIGIN,
    'dest=s'  => \$DEST,
    'projectdb!'  => \$opt_use_projectdb,
    'load-summary-description-origin!'  => \$opt_origin_load_summary_description,
    );

if (! $ENV{RPM_BUILD_ROOT}) {
    my $distromap_config=&DistroDBTools::read_distromap_config();
    my $origin_repo=$distromap_config->{'ORIGINREPO'};
    my $origin_branch=$distromap_config->{'ORIGINBRANCH'};
    my $dest_repo=$distromap_config->{'DESTREPO'};
    my $dest_branch=$distromap_config->{'DESTBRANCH'};
    $opt_use_projectdb=$distromap_config->{'USE_PROJECTDB'};
    $opt_origin_load_summary_description=$distromap_config->{'ORIGIN_LOAD_SUMMARY_DESCRIPTION'};

    $ORIGIN=$origin_repo.'/'.$origin_branch if $origin_repo and $origin_branch;
    $DEST=$dest_repo.'/'.$dest_branch if $dest_repo and $dest_branch;
}

sub process_options {
    if (!$ORIGIN or !$DEST) {
	die "Internal error: empty --origin or --dest";
    }
}


1;
