package DistroDB::CLI::Stems;

use strict;
use warnings;

use Exporter 'import';
our @EXPORT_OK = qw/@loaded_stems/;

use DistroDB::Stems qw/@mapper_stems/;
our @loaded_stems=@mapper_stems;
our $verbose=0;

my ($opt_stem);

our @LONGOPT=(
    'stem=s' => \$opt_stem,
    );

sub process_options {
    if (defined $opt_stem) {
	@loaded_stems=();
	@loaded_stems=split(/[,\s]+/,$opt_stem) if $opt_stem and $opt_stem ne 'none';
	print STDERR "new stems: [",join('|',@loaded_stems),"]\n" if $verbose;
	map {die 'bad stem '.$_ if !$DistroDB::Stems::known_stems{$_}} @loaded_stems;
    }
    print STDERR "loaded stems: [",join('|',@loaded_stems),"]\n" if $verbose;
}


1;
