package DistroDB::CreateRawQuiver;

use strict;
use warnings;
use DistroDB::Arrow qw/
&static_create_raw_arrow
&__arrow_create1
/;

our $verbose=0;

# --------------- 1-quiver implementation ------------

sub convert_pkg2stem2trait_to_quiver($) {
    my $map=shift;
    my @arrows=map {&__arrow_create1($map->{$_},$_)} keys(%$map);
}

sub create_map_pkg2pkg2stem2trait($$$) {
    my ($origin, $dest, $loaded_stems_ref)=@_;
    my $rawmap_origin2dest={};
    foreach my $stem ('same-libs.raw', @$loaded_stems_ref) {
	&pkg2pkg2stem2trait($origin, $dest, $stem, $rawmap_origin2dest);
    }
    return $rawmap_origin2dest;
}

sub pkg2pkg2stem2trait {
    my ($origin, $dest, $stem, $rawmap_origin2dest)=@_;
    print STDERR "generic_pretranslate_stem: stem=$stem ...\n" if $verbose;
    my $destdb=$dest->{$stem};
    my $origindb=$origin->{$stem};
    return unless $origindb or $destdb;
    foreach my $trait (keys(%$origindb)) {
	my $destset=$destdb->{$trait};
	next unless $destset;
	my $originset=$origindb->{$trait};
	foreach my $originpkg (@$originset) {
	    map {$rawmap_origin2dest->{$originpkg}->{$_}->{$stem}->{$trait}=1} @$destset;
	}
    }
}

# --------------------------------------------------

# --------------- N-quiver implementation ------------

sub __pkghash {
    return join(', ', sort @{$_[0]});
}

my %pkghash2pkgset;

sub convert_pkghash2fingerprint_to_quiver($) {
    my $map=shift;
    my @arrows=map {&static_create_raw_arrow($map->{$_},$pkghash2pkgset{$_})} keys(%$map);
}

sub create_map_pkg2pkghash2fingerprint($$$) {
    my ($origin, $dest, $loaded_stems_ref)=@_;
    my $rawmap_origin2dest={};
    foreach my $stem ('same-libs.raw', @$loaded_stems_ref) {
	&pkg2pkghash2fingerprint($origin, $dest, $stem, $rawmap_origin2dest);
    }
    return $rawmap_origin2dest;
}

sub pkg2pkghash2fingerprint {
    my ($origin, $dest, $stem, $rawmap_origin2dest)=@_;
    print STDERR "generic_pretranslate_stem: stem=$stem ...\n" if $verbose;
    my $destdb=$dest->{$stem};
    my $origindb=$origin->{$stem};
    return unless $origindb or $destdb;
    foreach my $trait (keys(%$origindb)) {
	my $destset=$destdb->{$trait};
	next unless $destset;
	my $hash=__pkghash($destset);
	$pkghash2pkgset{$hash}=$destset;
	my $originset=$origindb->{$trait};
	map {$rawmap_origin2dest->{$_}->{$hash}->{$stem}->{$trait}=1} @$originset;
    }
}

# --------------------------------------------------

sub same_repo_convert_pkghash2fingerprint_to_quiver($) {
    my ($map,$pkghash2pkgset)=@_;
    my @arrows=map {&static_create_raw_arrow($map->{$_},$pkghash2pkgset->{$_})} keys(%$map);
}

sub same_repo_create_map_pkg2pkghash2fingerprint($$) {
    my ($db,$loaded_stems_ref)=@_;
    my $__pkgs2set={};
    my %same_repo_pkghash2pkgset;
    foreach my $stem ('same-libs.raw', @$loaded_stems_ref) {
	#print STDERR "stem=$stem starting...\n" if $verbose;
	my $pkgdb=$db->{$stem};
	foreach my $trait (keys(%$pkgdb)) {
	    my $pkgset=$pkgdb->{$trait};
	    next unless $pkgset;
	    next if @$pkgset<2;
	    my $hash=__pkghash($pkgset);
	    $same_repo_pkghash2pkgset{$hash}=$pkgset;
	    map {$__pkgs2set->{$_}->{$hash}->{$stem}->{$trait}=1} @$pkgset;
	}
    }

    # TODO mvn provides

    return $__pkgs2set, \%same_repo_pkghash2pkgset;
}


1;
