package DistroDB::Pkgset;

# basic object: pkgset

use Carp;
use strict;
use warnings;

use Exporter 'import';
our @EXPORT_OK = qw/
&__is_pkgset_equal
&__is_pkgset_included
&__pkgset_merge
&__pkgset_create_hashstring
&__pkgset_pkgs
&__pkgset_get_pkgarrayref
&__pkgset_power
/;

sub __pkgset_get_pkgarrayref { return $_[0]}

sub __pkgset_create_hashstring {
    return join(', ', sort @{$_[0]});
}

sub __pkgset_get_power {
    return scalar @{$_[0]};
}

sub __is_pkgset_equal {
    my ($set1,$set2)=@_;
    return 0 if &__pkgset_get_power($set1)!= &__pkgset_get_power($set2);
    return 0 if &__pkgset_create_hashstring($set1) ne &__pkgset_create_hashstring($set2);
    return 1;
}

sub __is_pkgset_included {
    my ($set1,$set2)=@_;
    foreach my $pkg1 (@$set1) {
	my $found=0;
	IL2: foreach my $pkg2 (@$set1) {
	    if ($pkg1 eq $pkg2) {
		$found=1;
		last IL2;
	    }
	}
	return 0 unless $found;
    }
    return 1;
}

sub __pkgset_merge {
    my ($set1,$set2)=@_;
    my %merge=map {$_=>1} @$set1,@$set2;
    return [sort {$a cmp $b} keys(%merge)];
}

sub __pkgset_power {
    return scalar @{$_[0]};
}

sub __pkgset_pkgs {
    return @{$_[0]};
}


1;
