package ProjectDB::Repo::DistroDB;

use strict;
use warnings;

use ProjectDB::Pkg::DistroDB;

sub new {
    my $class=shift;
    my ($repo, $repoprefix, $dict)=@_;
    my $self={
	-repo => $repo,
	-dict => $dict,
	-repoprefix => $repoprefix,
	-_pkg_cache => {},
    };
    die 'Oops! no dict' if ! defined($dict);
    bless $self, $class;
}

sub get_pkg {
    my $self=shift;
    my ($name)=@_;
    my $toolpkg=$self->{-_pkg_cache}->{$name};
    unless ($toolpkg) {
	$toolpkg={};
	my $dict=$self->{-dict};
	$toolpkg->{NAME}=$name;
	$toolpkg->{VERSION}=$dict->{'srcversion.raw'}->{$name};
	my $filepath=$dict->{'srcfilepath.raw'}->{$name};
	unless ($filepath) {
	    my $pkg;
	    eval {
		$pkg=$self->{-repo}->name2pkg($name);
	    };
	    if (! defined($pkg) or $@) {
		warn "W: can't find rpm for ",$self->{-repoprefix},' ',$name;
		$filepath=$name.'-'.$toolpkg->{VERSION}.'-0unknown.src.rpm';
	    } else {
		$filepath=$pkg->file();
	    }
	}
	$toolpkg->{-source_name}=$filepath;
	$toolpkg->{URL}=$dict->{'sourceurl.raw'}->{$name};
	$toolpkg->{SUMMARY}=$dict->{'srcsummary.raw'}->{$name};
	my $desc=$dict->{'srcdescription.raw'}->{$name};
	$desc=~s/\\n/\n/g if $desc;
	$toolpkg->{DESCRIPTION}=$desc;
	#$toolpkg->{}=$dict->{''};

	$toolpkg=ProjectDB::Pkg::DistroDB->new($toolpkg,$name);
	$self->{-_pkg_cache}->{$name}=$toolpkg;
    }
    return $toolpkg;
}

1;
