package ProjectDB::Repo::RPM;

use strict;
use warnings;

use ProjectDB::Pkg::RPM;

sub new {
    my $class=shift;
    my ($repo, $repoprefix)=@_;
    my $self={
	-repo => $repo,
	-repoprefix => $repoprefix,
	-_pkg_cache => {},
    };
    bless $self, $class;
}

sub get_pkg {
    my $self=shift;
    my ($name)=@_;
    my $pkg=$self->{-repo}->name2pkg($name);
    if (! defined($pkg)) {
	warn "W: can't find rpm for ",$self->{-repoprefix},' ',$name;
	return undef;
    }
    my $toolpkg=$self->{-_pkg_cache}->{$name};
    unless ($toolpkg) {
	my $file=$pkg->file();
	$toolpkg=ProjectDB::Pkg::RPM->new($file,$name);
	$self->{-_pkg_cache}->{$name}=$toolpkg;
    }
    return $toolpkg;
}

1;
